import time
from math import inf

from bsition.backend.redis.utils import get_client

max_tokens = 10


def add_token(token, username, expire):
    client = get_client()
    client.zadd(username, {token: expire})


def remove_tokens(username):
    client = get_client()
    client.unlink(username)


def remove_token(username, token):
    client = get_client()
    tokens = client.zrangebyscore(username, -inf, inf)
    for aux in tokens:
        if aux.decode("utf-8") == token:
            client.zrem(username, token)


# Puede correr en un cron o, por ejemplo, cada vez que el usuario hace login (o logout)

def clean_tokens(username):
    client = get_client()
    client.zremrangebyscore(username, -inf, int(time.time()))


def valid_token(token, username):
    client = get_client()
    return client.zscore(username, token) is not None
